"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _lodash = _interopRequireDefault(require("lodash"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/* eslint-disable prettier/prettier */
/* eslint-disable @typescript-eslint/no-explicit-any */

// Copied from https://github.com/streamich/react-use

const useSetState = (initialState = {}) => {
  const [state, set] = (0, _react.useState)(initialState);
  const setState = (0, _react.useCallback)((patch, options) => {
    const replacer = options !== null && options !== void 0 && options.assign ? _lodash.default.assign : _lodash.default.merge;
    set(prevState => replacer({}, prevState, patch instanceof Function ? patch(prevState) : patch));
  }, []);
  return [state, setState];
};
var _default = exports.default = useSetState;
//# sourceMappingURL=useSetState.js.map